package com.zipcodewilmington;

import java.util.ArrayList;
import java.util.Arrays;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {

        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {

        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {

        return array[(array.length - 1)];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {
        return array[(array.length - 2)];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {

        for (int i = 0; i < array.length; i++)
            if (value.equals(array[i])) {
                return true;
            }
        return false;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        String[] newStr = new String[array.length];
        int n = 0;
        for (int i = array.length - 1; i >= 0; i--) {
            newStr[n] = array[i];
            n++;
        }
        return newStr;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {
        String[] newStr = Arrays.copyOf(array, array.length);
        boolean same = false;
        int n = 0;
        for (int i = array.length - 1; i >= 0; i--) {
            if (array[i] != newStr[n]) {
                return false;
            }
            n++;
        }
        return true;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {

        String str = String.join(",", array);
        String alphaStr = "abcdefghijklmnopqrstuvwxyz";
        char[] alphaArray = alphaStr.toCharArray();
        char[] charArray = str.toCharArray();

        int count = 0;
        for (int i = 0; i < alphaArray.length; i++) {
            for (int j = 0; j < charArray.length; j++) {
                if (alphaArray[i] == charArray[j]) {
                    count++;
                    //break;
                }
            }
        }
        if (count >= 26) {
            return true;
        }
        return false;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
        int counter = 0;
        for (int i = 0; i < array.length; i++) {
            if (array[i] == value) {
                counter++;
            }
        }

        return counter;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        String[] newStr = new String[array.length];
        int n = 0;
        for (int i = 0; i < array.length; i++) {
            if (array[i] != valueToRemove) {
                newStr[n] = array[i];
                n++;
            }

        }
        return Arrays.copyOf(newStr, n);


    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        int counter = 0;
        ArrayList<String> temp = new ArrayList<>();
        temp.add(array[0]);

        for (int i=1;i<array.length;i++) {
            if (!array[i].equals(temp.get(counter))) {
                temp.add(array[i]);
                counter++;
            }

        }
        String[] answer = new String[temp.size()];
        temp.toArray(answer);

        return answer;
    }



    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {

        int counter = 0;
        ArrayList<String> temp = new ArrayList<>();
        String str = array[0];


        for (int i=1;i<array.length;i++) {
            //if (array[i-1].charAt(0)!=(array[counter].charAt(0))) {

            if (array[i].equals(array[i-1])) {
                str=str.concat(array[i]);

            } else {
                temp.add(str);
                str="";
                str=str.concat(array[i]);
            }
        }
        
        temp.add(str);

         array = new String[temp.size()];
        temp.toArray(array);

        return array;
    }
}


